/* Block class for high intermediate representation.
 * In comparison to regular block for AST
 * it has no variable declarations and all statements
 * are represented as an array.
 *
*/

package IC.Hierarchy;
import IC.Error.*;
import IC.Semantic.*;
import IC.SymbolTable.*;
import IC.LowIR.*;
import java.util.*;

public class BlockHIR extends Stmt{

  //array of statements in the block
  public Stmt[] s;

  public SymTable blockSymTable;

  //Constructor for the block
  public BlockHIR (Stmt[] sts){
    s = sts;
  }
   public Var translate(){
    Var t;
	for(int i = 0; i<s.length; i++){
	  t = s[i].translate();
	}
	return t;
  }
  //Method for recursive printing of all children nodes in this block
  public void print(){
    for (int i = 0; i < s.length; i++)
      fprintln(nodenum+": "+"Block(N"+getNum(s[i])+");");
}

}
