/* Call class for high intermediate representation.
 * In comparison to regular call class for AST
 * all actuals are respresented as an array
 * of expressions instead of a tree-like structure.
 *
*/

package IC.Hierarchy;
import IC.LowIR.*;
import IC.Error.*;
import IC.Semantic.*;
import IC.SymbolTable.*;


public class CallHIR extends Method {

  //Array of actuals in method call
  public Node[] actuals;
  public Var translate(){
	Var f   = i.translate(); 
	Var t = new Var(LIR.getNextName());
	Var args[] = new Var[act.length];
	for(int i = 0; i<act.length; i++){
	  args[i] = act[i].translate();
	}
	LIR.irList.add(new IC.LowIR.Call(t,e.translate(),f,args));
	return t;
  }
  //Constructor for the call if method name is expression
  public CallHIR (Node e, Node i, Node[] act) {
    super(e, i);
    actuals = act;
  }

  //Constructor for the call if method name is just an identifier
  public CallHIR(Node i, Node[] act) {
    super(i);
    actuals =  act;
  }

  //Method for recursive printing of all children nodes in this block
   public void print(){

     if(actuals[0]!=null) {
       for (int index = 0; index < actuals.length; index++) {
         fprintln(nodenum + ": " + "Call(N" + getNum(e) + ",N" + getNum(i) +
                  ",N" + getNum(actuals[0]) + ");");
       }
     }

     if (String.valueOf(e) != "null") {
       e.print();
     }

     if (String.valueOf(i) != "null") {
       i.print();
     }
   }
}
