package IC.Hierarchy;

import IC.Error.*;
import IC.Semantic.*;
import IC.SymbolTable.*;
import IC.LowIR.*;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class IfElseStmt extends Stmt {
  public Expr ife;
  public Stmts s;
  public Stmts elses;

  public IfElseStmt(Node i, Node st, Node stelse) {
    ife = (Expr) i;
    s = (Stmts) st;
    elses = (Stmts) stelse;
  }
 public Var translate(){
    Var t1 = ife.translate();
	Var t = new Var(LIR.getNextName());
	String trueLabel = LIR.getNextLabel();
	String endLabel = LIR.getNextLabel();
	LIR.irList.add(new JumpC(t1,trueLabel));
	LIR.irList.add(new Copy(t,elses.translate()));
	LIR.irList.add(new Jump(endLabel));
	LIR.irList.add(new Label(trueLabel));
	LIR.irList.add(new Copy(t,s.translate()));
	LIR.irList.add(new Label(endLabel));
	
	return t;
  }
  public void print() {
    fprintln(nodenum + ": " + "IfElseStmt(N" + getNum(ife) + ",N" + getNum(s) +
             " N" + getNum(elses) + ");");
    if (String.valueOf(ife) != "null") {
      ife.print();
    }
    if (String.valueOf(s) != "null") {
      s.print();
    }
    if (String.valueOf(elses) != "null") {
      elses.print();
    }
  }

  public Object accept(Visitor v, SymTable st) throws SemanticError {
    return (v.visit(this, st));
  }

}