package IC.Hierarchy;

import IC.Error.*;
import IC.Semantic.*;
import IC.SymbolTable.*;
import IC.LowIR.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class IfStmt extends Stmt {
  public Expr e;
  public Stmts s;
  public IfStmt(Node exp, Node st) {
    e = (Expr) exp;
    s = (Stmts) st;
  }
  public Var translate(){
    Var t1 = e.translate();
	String trueLabel = LIR.getNextLabel();
	String falseLabel = LIR.getNextLabel();
	LIR.irList.add(new JumpC(t1,trueLabel));
	LIR.irList.add(new Jump(falseLabel));
	LIR.irList.add(new Label(trueLabel));
	s.translate();
	LIR.irList.add(new Label(falseLabel));
	return null;
  }
  public void print() {
    fprintln(nodenum + ": " + "IfStmt(N" + getNum(e) + ",N" + getNum(s) + ");");
    if (String.valueOf(e) != "null") {
      e.print();
    }
    if (String.valueOf(s) != "null") {
      s.print();
    }
  }

  public Object accept(Visitor v, SymTable st) throws SemanticError {
    return (v.visit(this, st));
  }

}